VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CAniView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'
' Brad Martinez http://www.mvps.org/ccrp
'
Private m_hCursor As Long
Private m_hWnd As Long
Private m_pt As POINTAPI
Private m_sz As SIZE
'

Private Sub Class_Terminate()
  Call DestroyAni
  Call DestroyStatic
End Sub

Public Function Create(sAniName As String, _
                                    hwndParent As Long, _
                                    x As Long, _
                                    y As Long) As Boolean
  Dim hCur As Long
  Dim hwndSt As Long
  Dim rc As RECT
  
  hCur = LoadCursorFromFile(sAniName)
  If hCur Then
    hwndSt = CreateWindowEx(0, STATIC_CLASSNAME, "", _
                                                WS_CHILD Or WS_VISIBLE Or SS_ICON, _
                                                x, y, 0, 0, _
                                                hwndParent, 0, _
                                                App.hInstance, ByVal 0)
    If hwndSt Then
      Call SendMessage(hwndSt, STM_SETIMAGE, IMAGE_CURSOR, ByVal hCur)
      
      Call DestroyAni
      Call DestroyStatic
      m_hWnd = hwndSt
      m_hCursor = hCur
      
      Call GetWindowRect(m_hWnd, rc)
      m_sz.cx = rc.Right - rc.Left
      m_sz.cy = rc.Bottom - rc.Top
    
      Create = True
      
    Else
      Call DestroyCursor(hCur)   ' hating...
    
    End If   ' hwndSt
  End If   ' hCur
  
End Function

Private Function DestroyAni() As Boolean
  If m_hCursor Then
    If DestroyCursor(m_hCursor) Then
      m_hCursor = 0
      DestroyAni = True
    End If
  End If
End Function

Private Function DestroyStatic() As Boolean
  If IsWindow(m_hWnd) Then
    If DestroyWindow(m_hWnd) Then
      m_hWnd = 0
      DestroyStatic = True
    End If
  End If
End Function

Public Property Get hCursor() As Long
  hCursor = m_hCursor
End Property

Public Property Get hWnd() As Long
  hWnd = m_hWnd
End Property

Public Property Get Left() As Long
  Left = m_pt.x
End Property

Public Property Let Left(x As Long)
  If m_hWnd Then
    m_pt.x = x
    Call SetWindowPos(m_hWnd, 0, m_pt.x, m_pt.y, 0, 0, _
                                    SWP_NOZORDER Or SWP_NOSIZE)
  End If
End Property

Public Property Get Top() As Long
  Top = m_pt.y
End Property

Public Property Let Top(y As Long)
  If m_hWnd Then
    m_pt.y = y
    Call SetWindowPos(m_hWnd, 0, m_pt.x, m_pt.y, 0, 0, _
                                    SWP_NOZORDER Or SWP_NOSIZE)
  End If
End Property

Public Property Get Width() As Long
  Width = m_sz.cx
End Property

Public Property Get Height() As Long
  Height = m_sz.cy
End Property
