Attribute VB_Name = "mWindowDefs"
Option Explicit
'
' Brad Martinez, www.mvps.org/ccrp
'
' ==================
' Windows API definitions
' ==================

Public Const vbBackslash = "\"
Public Const InvalidPathChars = "<*|?>"

Public Const HWND_DESKTOP = 0

Public Enum CBoolean
  CFalse = 0
  CTrue = 1
End Enum

Public Type POINTAPI   ' pt
  x As Long
  y As Long
End Type

Public Type SIZE   ' sz
  cx As Long
  cy As Long
End Type

Public Type RECT   ' rct
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Declare Function ReleaseCapture Lib "user32" () As Long
Declare Function GetCursor Lib "user32" () As Long
Declare Function SetCursor Lib "user32" (ByVal hCursor As Long) As Long
Declare Function LoadCursor Lib "user32" Alias "LoadCursorA" _
                            (ByVal hInstance As Long, lpCursorName As Any) As Long

Public Const IDC_WAIT = 32514&   ' Hourglass
Public Const IDC_ARROW = 32512&

Declare Function LoadCursorFromFile Lib "user32" Alias "LoadCursorFromFileA" (ByVal lpFileName As Any) As Long
Declare Function DestroyCursor Lib "user32" (ByVal hCursor As Long) As Boolean

Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Declare Function ScreenToClient Lib "user32" (ByVal hWnd As Long, lpPoint As Any) As Long  ' lpPoint As POINTAPI) As Long
Declare Function ClientToScreen Lib "user32" (ByVal hWnd As Long, lpPoint As Any) As Long  ' lpPoint As POINTAPI) As Long
Declare Function MapWindowPoints Lib "user32" (ByVal hwndFrom As Long, ByVal hwndTo As Long, lppt As Any, ByVal cPoints As Long) As Long

Declare Function InvalidateRect Lib "user32" (ByVal hWnd As Long, lpRect As Any, ByVal bErase As CBoolean) As Long
Declare Function UpdateWindow Lib "user32" (ByVal hWnd As Long) As Long
Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long

Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long

Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
'Declare Function AdjustWindowRect Lib "user32" (lpRect As RECT, ByVal dwStyle As WinStyles, ByVal bMenu As Boolean) As Boolean
Declare Function AdjustWindowRectEx Lib "user32" (lpRect As RECT, ByVal dwStyle As WinStyles, ByVal bMenu As CBoolean, ByVal dwExStyle As WinStylesEx) As Boolean

' All coordinates for child windows are client coordinates (relative
' to the upper-left corner of the parent window's client area).
Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As SWP_hWndInsertAfter, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal uFlags As SWP_Flags) As Long

Public Enum SWP_hWndInsertAfter
  HWND_TOP = 0
  HWND_BOTTOM = 1
  HWND_TOPMOST = 2
  HWND_NOTOPMOST = 3
End Enum

Public Enum SWP_Flags
  SWP_NOSIZE = &H1
  SWP_NOMOVE = &H2
  SWP_NOZORDER = &H4
  SWP_NOREDRAW = &H8
  SWP_NOACTIVATE = &H10
  SWP_FRAMECHANGED = &H20      ' The frame changed: send WM_NCCALCSIZE
  SWP_SHOWWINDOW = &H40
  SWP_HIDEWINDOW = &H80
  SWP_NOCOPYBITS = &H100
  SWP_NOOWNERZORDER = &H200    ' Don't do owner Z ordering
  SWP_NOSENDCHANGING = &H400   ' Don't send WM_WINDOWPOSCHANGING

  SWP_DRAWFRAME = SWP_FRAMECHANGED
  SWP_NOREPOSITION = SWP_NOOWNERZORDER

  SWP_DEFERERASE = &H2000
  SWP_ASYNCWINDOWPOS = &H4000
End Enum

Declare Function GetTickCount Lib "kernel32" () As Long
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)
'Declare Sub FillMemory Lib "kernel32" Alias "RtlFillMemory" (pDest As Any, ByVal dwLength As Long, ByVal bFill As Byte)

Declare Function LocalAlloc Lib "kernel32" (ByVal uFlags As LMemFlags, ByVal uBytes As Long) As Long
Declare Function LocalReAlloc Lib "kernel32" (ByVal hMem As Long, ByVal uBytes As Long, ByVal uFlags As LMemFlags) As Long
Declare Function LocalLock Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function LocalUnlock Lib "kernel32" (ByVal hMem As Long) As Boolean
Declare Function LocalFlags Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function LocalHandle Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function LocalSize Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function LocalFree Lib "kernel32" (ByVal hMem As Long) As Long

' Local Memory Flags
Public Enum LMemFlags
  LMEM_FIXED = &H0
  LMEM_MOVEABLE = &H2
  LMEM_NOCOMPACT = &H10
  LMEM_NODISCARD = &H20
  LMEM_ZEROINIT = &H40
  
  NONZEROLPTR = (LMEM_FIXED)
  NONZEROLHND = (LMEM_MOVEABLE)
  LPTR = (LMEM_FIXED Or LMEM_ZEROINIT)
  LHND = (LMEM_MOVEABLE Or LMEM_ZEROINIT)
  
  LMEM_MODIFY = &H80
  LMEM_DISCARDABLE = &HF00
  LMEM_VALID_FLAGS = &HF72
  LMEM_INVALID_HANDLE = &H8000
End Enum

Declare Function lstrcpyA Lib "kernel32" (lpString1 As Any, lpString2 As Any) As Long
Declare Function lstrlenA Lib "kernel32" (lpString As Any) As Long
Declare Function lstrcmpA Lib "kernel32" (lpString1 As Any, lpString2 As Any) As Long
Declare Function lstrcmpiA Lib "kernel32" (lpString1 As Any, lpString2 As Any) As Long

Declare Function lstrcpyW Lib "kernel32" (lpString1 As Any, lpString2 As Any) As Long
Declare Function lstrlenW Lib "kernel32" (lpString As Any) As Long
Declare Function lstrcmpW Lib "kernel32" (lpString1 As Any, lpString2 As Any) As Long
Declare Function lstrcmpiW Lib "kernel32" (lpString1 As Any, lpString2 As Any) As Long

'Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
'Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long

' ============================================
' Window messages

Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
                            (ByVal hWnd As Long, _
                            ByVal wMsg As WinMsgs, _
                            ByVal wParam As Long, _
                            lParam As Any) As Long   ' <---

Declare Function PostMessage Lib "user32" Alias "PostMessageA" _
                            (ByVal hWnd As Long, _
                            ByVal wMsg As WinMsgs, _
                            wParam As Any, _
                            lParam As Any) As Long   ' <---

'Public Type Msg   ' msg
'    hwnd As Long
'    message As Long
'    wParam As Long
'    lParam As Long
'    time As Long
'    pt As POINTAPI
'End Type

' Common to most controls
Public Enum WinMsgs
  WM_NULL = &H0
  WM_CREATE = &H1
  WM_DESTROY = &H2
  WM_MOVE = &H3
  WM_SIZE = &H5
  WM_ACTIVATE = &H6
  WM_SETFOCUS = &H7
  WM_KILLFOCUS = &H8
  WM_ENABLE = &HA
  WM_SETREDRAW = &HB
  WM_ACTIVATEAPP = &H1C
  WM_PAINT = &HF
  WM_ERASEBKGND = &H14
  WM_SYSCOLORCHANGE = &H15
  WM_WININICHANGE = &H1A
  WM_SETCURSOR = &H20
  WM_MOUSEACTIVATE = &H21
  WM_NEXTDLGCTL = &H28
  
  WM_SETFONT = &H30
  WM_GETFONT = &H31
  WM_WINDOWPOSCHANGED = &H47
  WM_NOTIFY = &H4E
  WM_CONTEXTMENU = &H7B
  WM_NCCREATE = &H81
  WM_NCDESTROY = &H82
  WM_NCCALCSIZE = &H83
  WM_GETDLGCODE = &H87
  WM_KEYDOWN = &H100
  WM_KEYUP = &H101
  WM_CHAR = &H102
  WM_COMMAND = &H111
  WM_SYSCOMMAND = &H112
  WM_TIMER = &H113
  WM_HSCROLL = &H114
  WM_VSCROLL = &H115

  WM_MOUSEMOVE = &H200
  WM_LBUTTONDOWN = &H201
  WM_LBUTTONUP = &H202
  WM_LBUTTONDBLCLK = &H203
  WM_RBUTTONDOWN = &H204
  WM_RBUTTONUP = &H205
  WM_RBUTTONDBLCLK = &H206
  WM_MBUTTONDOWN = &H207
  WM_MBUTTONUP = &H208
  WM_MBUTTONDBLCLK = &H209

  WM_PARENTNOTIFY = &H210
  WM_EXITMENULOOP = &H212
  WM_CAPTURECHANGED = &H215
  
  WM_USER = &H400
End Enum   ' WinMsgs

' ============================================
' Creation

Public Enum GWL_nIndex
  GWL_WNDPROC = (-4)
'  GWL_HWNDPARENT = (-8)
  GWL_ID = (-12)
  GWL_STYLE = (-16)
  GWL_EXSTYLE = (-20)
'  GWL_USERDATA = (-21)
End Enum

Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As GWL_nIndex) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As GWL_nIndex, ByVal dwNewLong As Long) As Long

Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" _
                            (ByVal dwExStyle As WinStylesEx, ByVal lpClassName As String, _
                             ByVal lpWindowName As String, ByVal dwStyle As WinStyles, _
                             ByVal x As Long, ByVal y As Long, _
                             ByVal nWidth As Long, ByVal nHeight As Long, _
                             ByVal hwndParent As Long, ByVal hMenu As Long, _
                             ByVal hInstance As Long, lpParam As Any) As Long

Public Enum WinStyles
  WS_OVERLAPPED = &H0
  WS_TABSTOP = &H10000
  WS_MAXIMIZEBOX = &H10000
  WS_MINIMIZEBOX = &H20000
  WS_GROUP = &H20000
  WS_THICKFRAME = &H40000
  WS_SYSMENU = &H80000
  WS_HSCROLL = &H100000
  WS_VSCROLL = &H200000
  WS_DLGFRAME = &H400000
  WS_BORDER = &H800000
  WS_CAPTION = (WS_BORDER Or WS_DLGFRAME)
  WS_MAXIMIZE = &H1000000
  WS_CLIPCHILDREN = &H2000000
  WS_CLIPSIBLINGS = &H4000000
  WS_DISABLED = &H8000000
  WS_VISIBLE = &H10000000
  WS_MINIMIZE = &H20000000
  WS_CHILD = &H40000000
  WS_POPUP = &H80000000
  
  WS_TILED = WS_OVERLAPPED
  WS_ICONIC = WS_MINIMIZE
  WS_SIZEBOX = WS_THICKFRAME
  
  ' Common Window Styles
  WS_OVERLAPPEDWINDOW = (WS_OVERLAPPED Or WS_CAPTION Or WS_SYSMENU Or WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX)
  WS_TILEDWINDOW = WS_OVERLAPPEDWINDOW
  WS_POPUPWINDOW = (WS_POPUP Or WS_BORDER Or WS_SYSMENU)
  WS_CHILDWINDOW = WS_CHILD
End Enum   ' WinStyles

Public Enum WinStylesEx
  WS_EX_DLGMODALFRAME = &H1
  WS_EX_NOPARENTNOTIFY = &H4
  WS_EX_TOPMOST = &H8
  WS_EX_ACCEPTFILES = &H10
  WS_EX_TRANSPARENT = &H20
  
  WS_EX_MDICHILD = &H40
  WS_EX_TOOLWINDOW = &H80
  WS_EX_WINDOWEDGE = &H100
  WS_EX_CLIENTEDGE = &H200
  WS_EX_CONTEXTHELP = &H400
  
  WS_EX_RIGHT = &H1000
  WS_EX_LEFT = &H0
  WS_EX_RTLREADING = &H2000
  WS_EX_LTRREADING = &H0
  WS_EX_LEFTSCROLLBAR = &H4000
  WS_EX_RIGHTSCROLLBAR = &H0
  
  WS_EX_CONTROLPARENT = &H10000
  WS_EX_STATICEDGE = &H20000
  WS_EX_APPWINDOW = &H40000
  
  WS_EX_OVERLAPPEDWINDOW = (WS_EX_WINDOWEDGE Or WS_EX_CLIENTEDGE)
  WS_EX_PALETTEWINDOW = (WS_EX_WINDOWEDGE Or WS_EX_TOOLWINDOW Or WS_EX_TOPMOST)
End Enum   ' WinStylesEx

' ============================================

Public Const MAX_PATH = 260

Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Public Type OPENFILENAME  '  ofn
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  flags As OFN_Flags
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type

' File Open/Save Dialog Flags
Public Enum OFN_Flags
  OFN_READONLY = &H1
  OFN_OVERWRITEPROMPT = &H2
  OFN_HIDEREADONLY = &H4
  OFN_NOCHANGEDIR = &H8
  OFN_SHOWHELP = &H10
  OFN_ENABLEHOOK = &H20
  OFN_ENABLETEMPLATE = &H40
  OFN_ENABLETEMPLATEHANDLE = &H80
  OFN_NOVALIDATE = &H100
  OFN_ALLOWMULTISELECT = &H200
  OFN_EXTENSIONDIFFERENT = &H400
  OFN_PATHMUSTEXIST = &H800
  OFN_FILEMUSTEXIST = &H1000
  OFN_CREATEPROMPT = &H2000
  OFN_SHAREAWARE = &H4000
  OFN_NOREADONLYRETURN = &H8000&
  OFN_NOTESTFILECREATE = &H10000
  OFN_NONETWORKBUTTON = &H20000
  OFN_NOLONGNAMES = &H40000               ' force no long names for 4.x modules
  OFN_EXPLORER = &H80000                       ' new look commdlg
  OFN_NODEREFERENCELINKS = &H100000
  OFN_LONGNAMES = &H200000                 ' force long names for 3.x modules
End Enum
'

' Returns the low-order word from the given 32-bit value.

Public Function LOWORD(dwValue As Long) As Long
  MoveMemory LOWORD, dwValue, 2
End Function

' Returns the high-order word from the given 32-bit value.

Public Function HIWORD(dwValue As Long) As Long
  MoveMemory HIWORD, ByVal VarPtr(dwValue) + 2, 2
End Function

' Returns the low-order byte from the given 16-bit value.

Public Function LOBYTE(wValue As Integer) As Byte
  MoveMemory LOBYTE, wValue, 1
End Function

' Returns the high-order byte from the given 16-bit value.

Public Function HIBYTE(wValue As Integer) As Byte
  MoveMemory HIBYTE, ByVal VarPtr(wValue) + 1, 1
End Function

' Combines two integers into a long integer

Public Function MAKELONG(wLow As Long, wHigh As Long) As Long
  MAKELONG = LOWORD(wLow) Or (&H10000 * LOWORD(wHigh))
End Function

' Combines two integers into a long integer

Public Function MAKELPARAM(wLow As Long, wHigh As Long) As Long
  MAKELPARAM = MAKELONG(wLow, wHigh)
End Function

Public Sub Hourglass(hWnd As Long, fOn As Boolean)
  If fOn Then
    ' Hourglass on!
    Call SetCapture(hWnd)
    Call SetCursor(LoadCursor(0, ByVal IDC_WAIT))
  Else
    ' Hourglass off!
    Call ReleaseCapture
    Call SetCursor(LoadCursor(0, IDC_ARROW))
  End If
End Sub

' Sets the specified style bits for the specified window.

'   hWnd           - specified window's handle
'   dwNewStyle - style to set
'   fExtended     - flag indicating whether the style is an extended style,
'                          if True, the style is extended, otherwise the style is normal
'   fAdd              - flag indicating whether the style is added or removed,
'                          if True, the style is added, otherwise the style is removed
'   fRedraw        - flag indicating whether to redraw the window so it detects the style change,
'                          if True, the window is redrawn, otherwise the window is not redrawn

' Returns True if the specified style is successfully added or removed,
' or is already set as specified. Returns False otherwise.

Public Function SetWindowStyle(hWnd As Long, _
                                                    dwNewStyle As Long, _
                                                    fExtended As Boolean, _
                                                    fAdd As Boolean, _
                                                    fRedraw As Boolean) As Boolean
  Dim dwStyleType As Long
  Dim dwCurStyle As Long

  If fExtended Then
    dwStyleType = GWL_EXSTYLE
  Else
    dwStyleType = GWL_STYLE
  End If

  dwCurStyle = GetWindowLong(hWnd, dwStyleType)   ' sets GetLastError
  ' Make sure everything went OK...
  If Err.LastDllError = 0 Then ' dwCurStyle could be zero!!!

    ' If adding the new style and is not currently set, set it.
    If fAdd And ((dwCurStyle And dwNewStyle) = 0) Then
      Call SetWindowLong(hWnd, dwStyleType, dwCurStyle Or dwNewStyle)

    ' If removing the new style and is currently set, clear it.
    ElseIf (fAdd = False) And (dwCurStyle And dwNewStyle) Then
      Call SetWindowLong(hWnd, dwStyleType, dwCurStyle And (Not dwNewStyle))
    End If

    ' Don't test equality, for some reason it returns False...???
    If fAdd Then
      SetWindowStyle = (dwNewStyle And GetWindowLong(hWnd, dwStyleType))
    Else
      SetWindowStyle = (dwNewStyle And (Not GetWindowLong(hWnd, dwStyleType)))
    End If

    If fRedraw Then Call SetWindowPos(hWnd, 0, _
                                                              0, 0, 0, 0, _
                                                              SWP_NOZORDER Or _
                                                              SWP_NOMOVE Or _
                                                              SWP_NOSIZE Or _
                                                              SWP_DRAWFRAME)
  End If

End Function
'
'Public Function OleColorToColorRef(clr As Long) As Long
'  If clr And &H80000000 Then
'    OleColorToColorRef = GetSysColor(clr And &HFF&)
'  Else
'    OleColorToColorRef = clr
'  End If
'End Function
'
'Public Function GetOpenFilePath(hwnd As Long, _
'                                                  sFilter As String, _
'                                                  sFile As String, _
'                                                  sInitDir As String, _
'                                                  sTitle As String, _
'                                                  sBuff As String) As Boolean
'  Dim ofn As OPENFILENAME
'  With ofn
'    .lStructSize = Len(ofn)
'    .hwndOwner = hwnd
'    .lpstrFilter = sFilter & vbNullChar & vbNullChar
'    .lpstrFile = sFile & String$(MAX_PATH - Len(sFile), 0)
'    .nMaxFile = MAX_PATH
'    .lpstrInitialDir = sInitDir
'    .lpstrTitle = sTitle & vbNullChar
'    .flags = OFN_HIDEREADONLY Or OFN_FILEMUSTEXIST
'  End With
'
'  If GetOpenFileName(ofn) Then
'    sBuff = GetStrFromBufferA(ofn.lpstrFile)
'    GetOpenFilePath = True
'  End If
'End Function

Public Function GetSaveFilePath(hWnd As Long, _
                                                sFilter As String, _
                                                sFile As String, _
                                                sInitDir As String, _
                                                sTitle As String, _
                                                sBuff As String) As Boolean
  Dim ofn As OPENFILENAME
  With ofn
    .lStructSize = Len(ofn)
    .hwndOwner = hWnd
    .lpstrFilter = sFilter & vbNullChar & vbNullChar
    .lpstrFile = sFile & String$(MAX_PATH - Len(sFile), 0)
    .nMaxFile = MAX_PATH
    .lpstrInitialDir = sInitDir
    .lpstrTitle = sTitle & vbNullChar
    .flags = OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT
  End With
  
  If GetSaveFileName(ofn) Then
    sBuff = GetStrFromBufferA(ofn.lpstrFile)
    GetSaveFilePath = True
  End If
End Function

' Returns the string before first null char encountered (if any) from an ANSII string.

Public Function GetStrFromBufferA(sz As String) As String
  If InStr(sz, vbNullChar) Then
    GetStrFromBufferA = Left$(sz, InStr(sz, vbNullChar) - 1)
  Else
    ' If sz had no null char, the Left$ function
    ' above would return a zero length string ("").
    GetStrFromBufferA = sz
  End If
End Function

' Returns an ANSII string from a pointer to an ANSII string.

Public Function GetStrFromPtrA(lpszA As Long) As String
  Dim sRtn As String
  sRtn = String$(lstrlenA(ByVal lpszA), 0)
  Call lstrcpyA(ByVal sRtn, ByVal lpszA)
  GetStrFromPtrA = sRtn
End Function

Public Function AlignLong(dw As Long) As Long
' /* Macro to align given value to the closest DWORD (unsigned long) */
' #define ALIGNULONG(i)   ((((i)+3) >> 2) << 2)
  AlignLong = ((dw + 3) \ 4) * 4
End Function

Public Function NormalizePath(sPath As String) As String
  If Right$(sPath, 1) <> "\" Then
    NormalizePath = sPath & "\"
  Else
    NormalizePath = sPath
  End If
End Function

' A dummy procedure that receives and returns the result
' of the AddressOf operator

Public Function FARPROC(pfn As Long) As Long
  FARPROC = pfn
End Function

' Returns the file or folder name after last "\"

Public Function GetLastItemInPath(sPath) As String
  Dim nPos1 As Integer
  Dim nPos2 As Integer
  
  If InStr(sPath, vbBackslash) = 0 Then
    GetLastItemInPath = sPath
  Else
    
    nPos1 = 1
    Do
      nPos2 = InStr(nPos1, sPath, vbBackslash)
      If nPos2 Then nPos1 = nPos2 + 1
    Loop While nPos2
    
    GetLastItemInPath = Mid$(sPath, nPos1, (Len(sPath) - nPos1) + 1)
  
  End If

End Function

Public Function ReplaceChars(ByVal sBuf As String, sOldChar As String, sNewChar As String) As String
  Dim nChars As Integer
  Dim i As Integer
  
  nChars = Len(sBuf)
  For i = 1 To nChars
    If InStr(sOldChar, Mid$(sBuf, i, 1)) Then
      Mid$(sBuf, i, 1) = sNewChar
    End If
  Next
  
  ReplaceChars = sBuf
  
End Function
